package com.chat.nuance.example1;


import com.android.volley.toolbox.Volley;
import com.nuance.chat.NuanMessaging;

public class Application extends android.app.Application{
    public static String dc;
    public static String clientId;
    public static String clientSec;
    public static String tagServerName;

    public NuanMessaging chatInstance;

    @Override
    public void onCreate() {
        super.onCreate();

        // Initialize NuanceConfiguration
        NuanceConfiguration.getInstance().init(getApplicationContext());

        // Set Token Parameters
        setTokenParams();

        chatInstance = NuanMessaging.getInstance();
        chatInstance.initialize(this, dc, clientId, clientSec, tagServerName, Volley.newRequestQueue(this));
    }

    private void setTokenParams() {
        dc = NuanceConfiguration.getInstance().getDc();
        clientSec = NuanceConfiguration.getInstance().getClientSec();
        clientId = NuanceConfiguration.getInstance().getClientId();
        tagServerName = NuanceConfiguration.getInstance().getTagServerName();
    }
}
