package com.nuance.example11;

import com.nuance.chat.NuanMessaging;
import com.nuance.translator.NinaMobileController;
import com.nuance.translator.NinaServerConfiguration;
import com.nuance.translator.recognition.RecognitionValues;

/**
 * Created by Mithun_Chackankulam on 8/9/2017.
 */
public class Application extends android.app.Application {

    public NuanMessaging chatInstance;
    @Override
    public void onCreate() {
        super.onCreate();
        chatInstance = NuanMessaging.getInstance();
        chatInstance.initialize(this, "west", "ceapiClientId", "ceapiClientSecret", "bestbrands");
        chatInstance.updateNuanceMessagingTitle("<big><b>HAVI</b></big>  <small><small><i>  Virtual assistant</i></small></small><br/><small>Visa grant 11803000000003</small>");
        initializeNinaMobileController();
    }

    private void initializeNinaMobileController() {
        NinaServerConfiguration ninaServerConfiguration = new NinaServerConfiguration.NinaServerConfigurationBuilder()
                .setApplicationKey("companyName_appName")
                .setVerificationCode("5796d9e101d5355f5dbf95a3681f6ca5317fd9e96e5ffacac5e1305361a4eb1c")
                .setGateWayScheme("wss")
                .setGateWayAddress("webapi-demo.nuance.mobi")
                .setGateWayPort(443)
                .setGateWayPath("webapi-platform/websocket")
                .build();
        NinaMobileController.getInstance().initialize(getApplicationContext(), ninaServerConfiguration);

        RecognitionValues recognitionValues = new RecognitionValues.RecognitionValuesBuilder()
                .setStartOfSpeechVoicedFrames(0)
                .setStartOfSpeechHistoryFrames(0)
                .build();
       // NinaMobileController.getInstance().getNinaSetting().setRecognitionValues(recognitionValues);
        NinaMobileController.getInstance().shouldDebugLog(true);
    }
}
