package com.nuance.sample2;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import androidx.appcompat.app.AppCompatActivity;

import com.nuance.Listener.NinaTransitionListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.GetMessageResponse;
import com.nuance.sample2.R;
import com.nuance.translator.ssml.SsmlBuilder;

import java.util.HashMap;


public class MainActivity extends AppCompatActivity {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_activity);


        System.loadLibrary("native-lib");
        TextView textView = findViewById(R.id.txt_log);
        NuanMessaging.getInstance().initialize(this, "west", getClientId(), getClientSecret(), "bestbrands");
        NuanMessaging.getInstance().overrideAuthDomain("https://auth-us1.digital.nuance.com");
        NuanMessaging.getInstance().overrideAPIDomain("https://api-us1.digital.nuance.com");

        textView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                launchChat(getProdEngageParameters(),null);
            }
        });




    }
    public HashMap<String, String> getProdEngageParameters() {
        HashMap<String, String> hashMap = new HashMap<String, String>();
        hashMap.put("siteID", "10003715");
        hashMap.put("buID", "13000508");
        hashMap.put("agID", "10004026");
        hashMap.put("brID", "20000");
        hashMap.put("autoID", "18000492");
        return hashMap;
    }


    public void launchChat(HashMap<String,String> hashMap, HashMap<String,String> datapass) {
        if (!NuanMessaging.getInstance().isChatInProgress()) {
            NuanMessaging.getInstance().setNuanceMessagingTitle(NuanMessaging.getVersion());
            NuanMessaging.getInstance().launchBrandedMessaging(MainActivity.this, hashMap, null, datapass);
        } else {
            NuanMessaging.getInstance().restoreBrandedMessaging(MainActivity.this,-1,hashMap);
        }
    }

    private native String getClientId();

    private native String getClientSecret();
}