package com.chat.nuance.example4;

import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import androidx.core.app.NotificationCompat;

import com.nuance.chat.constants.Constant;
import com.nuance.chat.constants.MessageTypes;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;

/**
 * Created by Mithun_Chackankulam on 8/30/2017.
 */
public class AgentMessageReciever extends BroadcastReceiver {

    NotificationManager manager;
    @Override
    public void onReceive(Context context, Intent intent) {
        String message  = "";
        try {
            JSONObject jsonObject = new JSONObject(intent.getStringExtra("message"));
            if(jsonObject.getString("messageType") != null && jsonObject.getString("messageType").equals(MessageTypes.TYPE_CHATLINE.getType())){
                addNotification(context,jsonObject.getString(Constant.MESSAGE_TEXT_PROP));
            } else if(jsonObject.getString("messageType") != null && jsonObject.getString("messageType").equals(MessageTypes.TYPE_STATECHANGE.getType())) {
                addNotification(context,jsonObject.getString(Constant.DISPLAY_TEXT_PROP));
            }


        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    private void addNotification(Context context,String msg) {
        NotificationCompat.Builder builder =
                (NotificationCompat.Builder) new NotificationCompat.Builder(context)
                        .setAutoCancel(true)
                        .setSmallIcon(R.drawable.agent_bubble_icon)
                        .setContentTitle("Agent send you a Message")
                        .setContentText(msg);


        Intent notificationIntent = new Intent("com.nuance.chat.BRANDED_CHAT_ACTIVIY");

        notificationIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK |
                Intent.FLAG_ACTIVITY_CLEAR_TASK);
        PendingIntent contentIntent = PendingIntent.getActivity(context, 0, notificationIntent,
                PendingIntent.FLAG_CANCEL_CURRENT);

        builder.setContentIntent(contentIntent);
        manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        manager.notify(0, builder.build());
    }
}
