package com.chat.nuance.example5;

import android.os.Bundle;
import android.os.PersistableBundle;

import android.view.MenuInflater;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;

import com.nuance.Listener.NinaTransitionListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.GetMessageResponse;
import com.nuance.chat.components.NuanceMessagingFragment;



import java.util.HashMap;

public class MainActivity extends AppCompatActivity implements  ChatLaunchFragment.OnLaunchClickListener,NuanceMessagingFragment.NuanceMessagingFragmentActionListener {

    NuanceMessagingFragment messagingFragment;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        System.out.println(getResources().getBoolean(R.bool.twoPaneMode));
        if (getResources().getBoolean(R.bool.twoPaneMode)) {
            return;
        }

            // cleanup any existing fragments in case we are in detailed mode
            getSupportFragmentManager().executePendingTransactions();
            Fragment fragmentById = getSupportFragmentManager().
                    findFragmentById(R.id.fragment_container);
            if (fragmentById!=null) {
                getSupportFragmentManager().beginTransaction()
                        .remove(fragmentById).commit();
            }

            ChatLaunchFragment chatLaunchFragment = new ChatLaunchFragment();
            getSupportFragmentManager().beginTransaction()
                    .replace(R.id.fragment_container, chatLaunchFragment).commit();

            NuanMessaging.getInstance().registerNinaTransitionListener(new NinaTransitionListener() {
                @Override
                public void onNinaTransition(String s) {

                }

                @Override
                public void onVAMessage(GetMessageResponse getMessageResponse) {

                }

                @Override
                public void interceptVAMessage(GetMessageResponse getMessageResponse) {

                }
            });

    }

    public void startChat(){
        HashMap<String,String> hashMap = new HashMap<String, String>();
        hashMap.put("siteID","10003715");
        hashMap.put("buID","13000508");
        hashMap.put("agID","10004026");
        hashMap.put("brID","20000");
        hashMap.put("autoID", "18000492");



        HashMap<String, String> datapass = new HashMap<String, String>();
        datapass.put("Test","tesing");

        HashMap<String, String> vars = new HashMap<String, String>();
        vars.put("agenID","10004026");
        NuanMessaging.getInstance().setNinaVars(vars,false);
        messagingFragment = NuanMessaging.getInstance().getBrandedMessagingFragment(this, hashMap, null, datapass);
        messagingFragment.setNuanceMessagingFragmentActionListener(this);



    }



    @Override
    public void onLaunch() {
        if (getResources().getBoolean(R.bool.twoPaneMode)) {
            startChat();
            getSupportFragmentManager().beginTransaction().add(R.id.chatFragment, messagingFragment).
                    commit();
        } else {
            // replace the fragment
            // Create fragment and give it an argument for the selected article
            startChat();
            FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();

            // Replace whatever is in the fragment_container view with this fragment,
            // and add the transaction to the back stack so the user can navigate back

            transaction.replace(R.id.fragment_container, messagingFragment);
            transaction.addToBackStack(null);

            // Commit the transaction
            transaction.commit();
        }
    }

    @Override
    public void onSaveInstanceState(Bundle outState, PersistableBundle outPersistentState) {
        super.onSaveInstanceState(outState, outPersistentState);
        if(messagingFragment!=null) {
            getSupportFragmentManager().putFragment(outState, "messageListFrag", messagingFragment);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(com.nuance.chat.R.menu.menu_messaging, menu);
        return true;
    }

    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        MenuItem min = menu.findItem(com.nuance.chat.R.id.action_minimize);
        if(min!= null && messagingFragment != null) {
            if (messagingFragment.isPostChatSurveyDisplayed()
                    && messagingFragment.hasAgentLeft()) {
                min.setVisible(false);
            } else if (messagingFragment.isChatInProgress()) {
                min.setVisible(true);
            }
        }
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        if (id == com.nuance.chat.R.id.action_close) {
            if(messagingFragment != null){
                messagingFragment.onClose();
            }
        }
        if (id == com.nuance.chat.R.id.action_minimize) {
            if(messagingFragment != null){
                messagingFragment.onMinimize();
            }
        }
        return id == com.nuance.chat.R.id.action_close || super.onOptionsItemSelected(item);
    }

    @Override
    public void onFinish() {
        finish();
    }

    @Override
    public void refreshMenu() {
        invalidateOptionsMenu();
    }
}
