package com.chat.nuance.example6;

import android.os.Bundle;

import android.util.Log;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;
import com.nuance.Listener.OnErrorListener;
import com.nuance.Listener.OnSuccessListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.EngageStatusResponse;
import com.nuance.chat.Responses.Response;
import com.nuance.chat.constants.Constant;

import java.util.HashMap;

public class MainActivity extends AppCompatActivity {

    NuanMessaging nuanMessaging;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        nuanMessaging =  NuanMessaging.getInstance();
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });

        HashMap<String,String> hashMap = new HashMap<String, String>();
        hashMap.put("siteID","10003715");
        hashMap.put("buID","13000508");
        hashMap.put("agID","10004026");
        hashMap.put("brID","20000");
        try {
            nuanMessaging.closeEngagement();
        }catch (IllegalStateException e){}

            nuanMessaging.createMessagingEngagment(hashMap, null ,
                    new OnSuccessListener<EngageStatusResponse>() {
                        @Override
                        public void onResponse(EngageStatusResponse response) {
                            switch (response.getStatus()){
                                case Constant.DENIED:

                                    break;
                                case Constant.QUEUED:

                                case Constant.ACCEPTED:

                                    break;

                            }
                        }
                    }, new OnErrorListener() {
                        @Override
                        public void onErrorResponse(Response response) {

                            Log.e("Nuance Messaging","Engage Request:error code:"+response.getStatusCode());

                        }
                    });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_close) {
            try {
                nuanMessaging.closeEngagement();
            }catch (IllegalStateException e){

            }
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        try {
            nuanMessaging.closeEngagement();
        }catch (IllegalStateException e){

        }
    }
}
