package com.chat.nuance.example8;

import android.content.res.Resources;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.recyclerview.widget.RecyclerView;

import com.nuance.chat.persistence.Message;
import com.nuance.chatui.BubbleChatLine;
import com.nuance.chatui.bubble.ArrowDirection;
import com.nuance.chatui.bubble.BubbleType;

import java.util.List;

public class TranscriptMessageRecyclerViewAdapter extends RecyclerView.Adapter<TranscriptMessageRecyclerViewAdapter.ViewHolder> {

    private final List<Message> mValues;

    public TranscriptMessageRecyclerViewAdapter(List<Message> items) {
        mValues = items;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        Resources resources = parent.getContext().getResources();
        View view = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.message_item, parent, false);

        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(final ViewHolder holder, int position) {
        Message message = holder.mItem = mValues.get(position);
       if(message.getType() == BubbleType.AGENT_MESSAGE){
            holder.bubbleChatLine.setBubbleTypeTextDirection(message.getType(),message.getMessageText(),"test", ArrowDirection.TOP_LEFT);
        } else if(message.getType() == BubbleType.CUSTOMER_MESSAGE) {
            holder.bubbleChatLine.setBubbleTypeTextDirection(message.getType(),message.getMessageText(),"test", ArrowDirection.BOTTOM_RIGHT);
        } else if(message.getType() == BubbleType.TYPING_MESSAGE || message.getType() == BubbleType.SYSTEM_MESSAGE) {
            holder.bubbleChatLine.setBubbleTypeTextDirection(message.getType(),message.getMessageText(),"test", ArrowDirection.NONE);
        }
    }


    @Override
    public int getItemCount() {
        return mValues.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        public final View mView;

        public BubbleChatLine bubbleChatLine;
        public Message mItem;

        public ViewHolder(View view) {
            super(view);
            mView = view;
            bubbleChatLine = (BubbleChatLine) view.findViewById(R.id.message_list_item);
        }

        @Override
        public String toString() {
            return "";
        }
    }
}
