package com.example.typinganimation;

import android.os.Bundle;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;
import com.nuance.Listener.OnErrorListener;
import com.nuance.Listener.OnSuccessListener;
import com.nuance.Listener.WindowStateListener;
import com.nuance.chat.ConversationStatusAPI;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.GetMessageResponse;
import com.nuance.chat.Responses.PendingMessageResponse;
import com.nuance.chat.Responses.Response;
import com.nuance.chat.constants.MessagingErrorState;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import android.view.View;
import android.view.Menu;
import android.view.MenuItem;

import java.util.HashMap;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        FloatingActionButton fab = findViewById(R.id.fab);

        //if Async chat then pass the unique customer id
        //NuanMessaging.getInstance().getProfileManager().setUniqueCustomerId("email", "test@test.com");

        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                HashMap<String, String> hashMap = new HashMap<String, String>();

                hashMap.put("siteID", "10003715");
                hashMap.put("buID", "13000508");
                hashMap.put("agID", "10004026");
                hashMap.put("brID", "20000");

                hashMap.put("openerText", "Hello what'sup");

                hashMap.put("customerName", "Test");

                if (!NuanMessaging.getInstance().isChatInProgress()) {
                    HashMap<String, String> datapass = new HashMap<String, String>();
                    NuanMessaging.getInstance().launchBrandedMessaging(MainActivity.this, hashMap, null, datapass);
                } else {
                    NuanMessaging.getInstance().restoreBrandedMessaging(MainActivity.this, -1, hashMap);
                }

            }
        });


        NuanMessaging.getInstance().setMessageOnMinimizedListener(new OnSuccessListener<GetMessageResponse>() {
            @Override
            public void onResponse(GetMessageResponse response) {
                System.out.println(response.getMessageType());
                //show a visual feedback to customer by displaying a counter or something
            }
        });

        NuanMessaging.getInstance().setOnWindowStateListener(new WindowStateListener() {
            @Override
            public void onMinimized() {

            }

            @Override
            public void onClosed() {

            }

            @Override
            public void onAssigned(String name) {
                NuanMessaging.getInstance().updateNuanceMessagingTitle("Taling to " + name);
                NuanMessaging.getInstance().updateNuanceMessagingLogo(R.drawable.agent_bubble_icon);
            }

            @Override
            public void onEngagementCreated() {

            }

            @Override
            public void onEngagementEnded() {

            }

            @Override
            public void onConversationResolved() {

            }

            @Override
            public void onError(MessagingErrorState messagingErrorState) {

            }
        });
    }

    @Override
    protected void onStart() {
        super.onStart();

        if (NuanMessaging.getInstance().isChatInProgress()) {
            //Display restoreButton
        } else {
            //if Async chat
            /*
            ConversationStatusAPI ConvStatus = new ConversationStatusAPI();

                ConvStatus.hasPendingMessages("10003715", new OnSuccessListener<PendingMessageResponse>() {
                    @Override
                    public void onResponse(PendingMessageResponse pendingMessageResponse) {
                        if(pendingMessageResponse.hasPendingMessages()) {
                            //show restore buttton
                        } else {
                            //show click to chat button
                        }
                    }
                }, new OnErrorListener() {
                    @Override
                    public void onErrorResponse(Response response) {
                        //show click to chat button
                    }
                });
                */
            //else
            //Display a click to chat button
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
