package com.chat.nuance.v2example;

import android.os.Bundle;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.nuance.Listener.RecommendationListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.RecommendationResponse;

import java.util.HashMap;

public class Confirmation extends AppCompatActivity {

    HashMap<String,String> engageParams;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_confirmation);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        final FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                HashMap<String, String> datapass = new HashMap<String, String>();
                datapass.put("pageMarker","Confirmation");
                NuanMessaging.getInstance().launchBrandedMessaging(Confirmation.this,engageParams, null, datapass);
            }
        });

        NuanMessaging.getInstance().getRecommendation("onAnyEvent",null);

        NuanMessaging.getInstance().setRecommendationListener(new RecommendationListener() {
            @Override
            public void onRecommendation(RecommendationResponse recommendationResponse) {

                if(recommendationResponse.getName().equals("START_CHAT")) {
                    fab.setVisibility(View.VISIBLE);
                    System.out.println(recommendationResponse.getDatum());

                    engageParams = recommendationResponse.getDatum();
                }
            }
        });
    }

}
