package com.chat.nuance.v2example;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;


public class CustomAdapter  extends BaseAdapter {

    private Context context;
    private ArrayList<ImageModel> imageModelArrayList;
    private View.OnClickListener clickListener;


    public CustomAdapter(Context context, ArrayList<ImageModel> imageModelArrayList, View.OnClickListener clickListener) {

        this.context = context;
        this.imageModelArrayList = imageModelArrayList;
        this.clickListener = clickListener;

    }

    @Override
    public int getViewTypeCount() {
        return getCount();
    }
    @Override
    public int getItemViewType(int position) {

        return position;
    }

    @Override
    public int getCount() {
        return imageModelArrayList.size();
    }

    @Override
    public Object getItem(int position) {
        return imageModelArrayList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;

        if (convertView == null) {
            holder = new ViewHolder(); LayoutInflater inflater = (LayoutInflater) context
                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            if(this.clickListener == null){
                convertView = inflater.inflate(R.layout.lv_item1, null, true);
            }  else {
                convertView = inflater.inflate(R.layout.lv_item, null, true);
            }

            holder.tvname = (TextView) convertView.findViewById(R.id.name);
            holder.iv = (ImageView) convertView.findViewById(R.id.imgView);
            holder.checkBox = (CheckBox)convertView.findViewById(R.id.checkBox);
            holder.price = (TextView)convertView.findViewById(R.id.price);
            if(this.clickListener != null) {
                holder.checkBox.setOnClickListener(this.clickListener);
            }

            convertView.setTag(holder);
        }else {
            // the getTag returns the viewHolder object set as a tag to the view
            holder = (ViewHolder)convertView.getTag();
        }

        holder.tvname.setText(imageModelArrayList.get(position).getName());
        holder.iv.setImageResource(imageModelArrayList.get(position).getImage_drawable());
        if(holder.price != null) {
            holder.price.setText(String.valueOf(imageModelArrayList.get(position).getPrice()));
        }

        return convertView;
    }

    private class ViewHolder {

        protected TextView tvname;
        private ImageView iv;
        private CheckBox checkBox;
        private TextView price;

    }

}