package com.chat.nuance.v2example;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.nuance.Listener.OnSuccessListener;
import com.nuance.Listener.RecommendationListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.RecommendationResponse;
import com.nuance.chat.Responses.Response;

import java.util.ArrayList;
import java.util.HashMap;

public class SaleActivity extends AppCompatActivity {

    Button addcart;

    HashMap<String,String> engageParams;

    Button nextBtn;
    int count;
    double price = 0;
    private ListView lv;
    private CustomAdapter customAdapter;
    private ArrayList<ImageModel> imageModelArrayList;
    private int[] myImageList = new int[]{R.drawable.benz, R.drawable.bike,
            R.drawable.car,R.drawable.carrera
            ,R.drawable.ferrari,R.drawable.harly,
            R.drawable.lamborghini,R.drawable.silver};
    private String[] myImageNameList = new String[]{"Benz", "Bike",
            "Car","Carrera"
            ,"Ferrari","Harly",
            "Lamborghini","Silver"};

    private double[] priceList = new double[]{500, 100,
            200,300
            ,50,10,
            230,45};

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sale);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        //nextBtn = (Button)findViewById(R.id.next);

        lv = (ListView) findViewById(R.id.listView);
        imageModelArrayList = populateList();
        customAdapter = new CustomAdapter(this, imageModelArrayList, new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //if(((CheckBox)view).isChecked())
                 //   count++;
            }
        });



        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                if(!((CheckBox)view.findViewById(R.id.checkBox)).isChecked()){
                    ((CheckBox)view.findViewById(R.id.checkBox)).setChecked(true);
                    count+=1;
                    price += Double.valueOf(((TextView)view.findViewById(R.id.price)).getText().toString());
                } else {
                    ((CheckBox)view.findViewById(R.id.checkBox)).setChecked(false);
                    count-=1;
                    price -= Double.valueOf(((TextView)view.findViewById(R.id.price)).getText().toString());
                }


            }
        });
        lv.setAdapter(customAdapter);


        if(NuanMessaging.getInstance().isBRReady()){
            final HashMap<String,Object> data = new HashMap<String, Object>();
            data.put("PageMarker","Sale");
            NuanMessaging.getInstance().getRecommendation("onAnyEvent",data);
        } else {
            NuanMessaging.getInstance().whenBRReadyListener(new OnSuccessListener<Response>() {
                @Override
                public void onResponse(Response response) {
                    final HashMap<String,Object> data = new HashMap<String, Object>();
                    data.put("PageMarker","Sale");
                    NuanMessaging.getInstance().getRecommendation("onAnyEvent",data);
                }
            });
        }
        addcart = (Button)findViewById(R.id.addcart);
        final FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(engageParams != null) {
                    HashMap<String, String> datapass = new HashMap<String, String>();
                    datapass.put("pageMarker","Sale");
                    NuanMessaging.getInstance().launchBrandedMessaging(SaleActivity.this,engageParams, null, datapass);
                }
            }
        });

        NuanMessaging.getInstance().setRecommendationListener(new RecommendationListener() {
            @Override
            public void onRecommendation(RecommendationResponse recommendationResponse) {

                if(recommendationResponse.getName().equals("START_CHAT")) {
                    fab.setVisibility(View.VISIBLE);
                    System.out.println(recommendationResponse.getDatum());

                    engageParams = recommendationResponse.getDatum();
                }
            }
        });

        addcart.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
               /* if(count ==0) {
                    Toast.makeText(SaleActivity.this,"Cart is empty.",Toast.LENGTH_SHORT).show();
                    return;
                }*/
                Intent i = new Intent(SaleActivity.this,cart.class);
                i.putExtra("item",count);
                i.putExtra("price",price);
                SaleActivity.this.startActivity(i);
            }
        });
    }

    private ArrayList<ImageModel> populateList(){

        ArrayList<ImageModel> list = new ArrayList<>();

        for(int i = 0; i < 8; i++){
            ImageModel imageModel = new ImageModel();
            imageModel.setName(myImageNameList[i]);
            imageModel.setImage_drawable(myImageList[i]);
            imageModel.setPrice(priceList[i]);
            list.add(imageModel);
        }

        return list;

    }

}
