package com.chat.nuance.v2example;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ListView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.nuance.Listener.RecommendationListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.RecommendationResponse;
import com.nuance.profile.ConversionEvent;

import org.w3c.dom.Text;

import java.util.ArrayList;
import java.util.HashMap;

public class cart extends AppCompatActivity {

    TextView textView;
    private int[] myImageList;
    private ListView lv;
    private CustomAdapter customAdapter;
    Button checkout;

    HashMap<String,String> engageParams;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cart);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        lv = (ListView) findViewById(R.id.listView);
        ArrayList<ImageModel> list = new ArrayList<>();

        for(int i = 0; i < getIntent().getIntExtra("item",0); i++){
            ImageModel imageModel = new ImageModel();
            imageModel.setName("Ferrari");
            imageModel.setImage_drawable(R.drawable.car);
            list.add(imageModel);
        }

        final FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(engageParams != null) {
                    HashMap<String, String> datapass = new HashMap<String, String>();
                    datapass.put("pageMarker","cart");
                    NuanMessaging.getInstance().launchBrandedMessaging(cart.this,engageParams, null, datapass);
                }
            }
        });

        textView = (TextView)findViewById(R.id.cartCount);
        textView.setText("Items in Cart: "+ getIntent().getIntExtra("item",0));

        customAdapter = new CustomAdapter(this, list, null);
        if(list.size()>0) {
            lv.setAdapter(customAdapter);
        }
        checkout = (Button) findViewById(R.id.checkout);
        checkout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                NuanMessaging.getInstance().getProfileManager().sendConversionEvent(ConversionEvent.builder()
                        .addProductName("Ferrari")
                        .addCount(getIntent().getIntExtra("item",0))
                        .addType("car")
                        .addValue(getIntent().getDoubleExtra("price",0)));
                cart.this.startActivity(new Intent(cart.this, Confirmation.class));
            }
        });

        final HashMap<String,Object> data = new HashMap<String, Object>();
        data.put("cartcount", list.size());
        NuanMessaging.getInstance().getRecommendation("onAnyEvent", data);

        NuanMessaging.getInstance().setRecommendationListener(new RecommendationListener() {
            @Override
            public void onRecommendation(RecommendationResponse recommendationResponse) {

                if(recommendationResponse.getName().equals("START_CHAT")) {
                    fab.setVisibility(View.VISIBLE);
                    System.out.println(recommendationResponse.getDatum());

                    engageParams = recommendationResponse.getDatum();
                }
            }
        });
    }

}
