package com.chat.nuance.v2example;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.EditText;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;
import com.nuance.Listener.OnErrorListener;
import com.nuance.Listener.OnSuccessListener;
import com.nuance.chat.NuanMessaging;
import com.nuance.chat.Responses.ProfileResponse;
import com.nuance.chat.Responses.Response;
import com.nuance.profile.DCEvent;
import com.nuance.profile.ProfileManager;

public class login extends AppCompatActivity {

    Button login;
    NuanMessaging nuanMessaging;
    EditText emailField;
    ProgressDialog progress;
    boolean isRunning = false;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        nuanMessaging = NuanMessaging.getInstance();
        setContentView(R.layout.activity_login);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        login = (Button) findViewById(R.id.loginbutton);
        emailField = (EditText) findViewById(R.id.email);
        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });

        login.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                progress = new ProgressDialog(login.this);
                progress.setMessage("login in");
                progress.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
                progress.setIndeterminate(true);
                progress.show();
                final int totalProgressTime = 100;
                final Thread t = new Thread() {
                    @Override
                    public void run() {
                        int jumpTime = 0;
                        isRunning = true;
                        while(jumpTime < totalProgressTime && isRunning) {
                            try {
                                sleep(400);
                                jumpTime += 5;
                                progress.setProgress(jumpTime);
                                if(jumpTime>=totalProgressTime) {
                                    login.this.startActivity(new Intent(login.this, SaleActivity.class));
                                }
                            } catch (InterruptedException e) {
                                // TODO Auto-generated catch block
                                e.printStackTrace();
                                isRunning = false;
                            }
                        }


                    }
                };
                t.start();
                if(!emailField.getText().toString().isEmpty()) {
                    nuanMessaging.getProfileManager().setUniqueCustomerId("email", emailField.getText().toString());
                    nuanMessaging.getProfileManager().startSession("10003715", "verizon_app", ProfileManager.Interval.NOW, new OnSuccessListener<ProfileResponse>() {
                        @Override
                        public void onResponse(ProfileResponse profileResponse) {
                            System.out.println("sesion created");
                            //TelephonyManager tMgr = (TelephonyManager)login.this.getSystemService(Context.TELEPHONY_SERVICE);
                            String mPhoneNumber = "8550001111";
                            if(!mPhoneNumber.isEmpty()) {
                                nuanMessaging.getProfileManager().sendCustomEvent(DCEvent.builder().addName("phone").addValue(mPhoneNumber).addType(DCEvent.Type.VISITOR_ATTRIBUTE).addAction(DCEvent.Action.APPEND).isUniqueCustomerID(DCEvent.UniqueID.YES));
                            }
                            login.this.startActivity(new Intent(login.this, SaleActivity.class));
                            t.interrupt();
                        }
                    }, new OnErrorListener() {
                        @Override
                        public void onErrorResponse(Response response) {
                            System.out.println(response.getStatusCode());
                            login.this.startActivity(new Intent(login.this, SaleActivity.class));
                            t.interrupt();
                        }
                    });




                }

            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_login, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
